<template>
  <v-layout align-center justify-center row wrap color="#f8f8f8" display: flex>
<v-flex md12 pa-1 >
        <v-layout >
      <v-flex md11 align-center>
        <div class="font-size-24-bold">E-Withholding Tax</div>
      </v-flex>
      <v-flex md1></v-flex>
      <v-flex xs4 v-if="!mobileView"></v-flex>
       <v-flex xs1 py-3 px-5 v-if="!mobileView">
        <v-btn
          flat small
          @click="exportmodal = true"
          color="grey"
          class="white--text">EXPORT
          <v-icon color="blue-grey">mdi-download</v-icon>
          </v-btn>
      </v-flex>
      <v-flex xs1  v-if="!mobileView"></v-flex>
      <v-flex xs5 align-center py-3 v-if="!mobileView">
          <v-text-field color="#538795"
            solo
            light
            label="search"
            hide-details
            v-model="whtSearch"
            append-icon="search">
          </v-text-field>
      </v-flex>
    </v-layout>
    <v-layout>
      <v-flex xs12 align-center v-if="mobileView">
          <v-text-field color="#538795"
            solo
            light
            label="search"
            hide-details
            v-model="whtSearch"
            append-icon="search"
            style="padding-top:10px;"
          >
          </v-text-field>
      </v-flex>
    </v-layout>
    <v-layout v-if="mobileView">
      <v-flex xs10></v-flex>
      <v-flex xs2 align-center >
          <v-btn
          flat icon small
          @click="exportmodal = true"
          color="grey"
          class="white--text">EXPORT
          <v-icon color="blue-grey">mdi-download</v-icon>
          </v-btn>
      </v-flex>
    </v-layout>
      <div>
          <v-card>
          <v-flex md12 pa-1>
            <!-- table desktop -->
              <v-data-table
                :rows-per-page-items="rowperpage"
                class="elevation-0 custom-table-cell"
                :headers="headers"
                :items="billsview"
                :search="whtSearch"
                :loading="istableloading"
                item-key="Invoice_no"
                v-if="!mobileView"
                disable-initial-sort
              >
                <template v-slot:items="props" v-bind:class="{'active-class-name': isActive(sidemenu)}" >
                  <tr style="cursor: pointer;">
                    <!-- <td class="text-xs-center">{{ props.index + 1}}</td> -->
                    <td @click="openinvoicemodal(props.item.invoice_no)" style="color:#538795;"><strong>{{ props.item.payment_data[0].Payment_no }}</strong></td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" style="color:#538795;"><strong>{{ props.item.invoice_no }}</strong></td>
                    <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-center">{{ props.item.company_name }}</td>
                    <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-center">{{ props.item.createdAt }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.amount }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.wht_rate }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.wht_amount_pay }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.pay_amount }}</td>
                    <td class="text-xs-center">
                      <v-chip
                        :color="props.item.wht_status === 'RD Verified' ? 'success' : 'grey'"
                        v-if="props.item.wht_status"
                        text-color="white"
                        text-font="center"
                        style= "width:75px; justify-content: center;"
                      >{{ props.item.wht_status }}</v-chip>
                    </td>
                    <!-- <td v-if="props.item.transref.pay_type" class="text-xs-center">{{ props.item.transref.pay_type }}</td>
                    <td v-if="!props.item.transref.pay_type" class="text-xs-center">-</td>
                    <td style="padding:0px 10px;" class="text-xs-center">{{ props.item.transref.transaction_date }}</td> -->
                  </tr>
                </template>
              </v-data-table>
              <!-- end table desktop -->
              <!-- table mobile -->
              <v-data-table
                :rows-per-page-items="rowperpage"
                class="elevation-0 custom-table-cell"
                :headers="headers"
                :items="billsview"
                :search="whtSearch"
                :loading="istableloading"
                item-key="Invoice_no"
                v-if="mobileView"
                disable-initial-sort
              >
                <template v-slot:items="props" v-bind:class="{'active-class-name': isActive(sidemenu)}" >
                  <tr style="cursor: pointer;">
                    <!-- <td class="text-xs-center">{{ props.index + 1}}</td> -->
                    <td @click="openinvoicemodal(props.item.invoice_no)" style="color:#538795;"><strong>{{ props.item.payment_data[0].Payment_no }}</strong></td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" style="color:#538795;"><strong>{{ props.item.invoice_no }}</strong></td>
                    <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-center">{{ props.item.company_name }}</td>
                    <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-center">{{ props.item.createdAt }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.amount }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.wht_rate }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.wht_amount_pay }}</td>
                    <td @click="openinvoicemodal(props.item.invoice_no)" class="text-xs-right">{{ props.item.pay_amount }}</td>
                    <td class="text-xs-right">
                      <v-chip
                        :color="props.item.wht_status === 'RD Verified' ? 'success' : 'grey'"
                        v-if="props.item.wht_status"
                        text-color="white"
                        text-font="center"
                        style= "width:85px; justify-content: center;"
                      >{{ props.item.wht_status }}</v-chip>
                    </td>
                  </tr>
                </template>
              </v-data-table>
              <!-- end table mobile -->
          </v-flex>
        </v-card>
      </div>
      <div>
      </div>
    </v-flex>
    <Invoicemodal />
    <Exportmodal/>
  </v-layout>
</template>

<script>
import { sync } from 'vuex-pathify'
import Invoicemodal from '@/components/Invoicemodal'
import Exportmodal from '@/components/Exportmodal'
import moment from 'moment'
moment.locale('en')
export default {
  components: {
    Invoicemodal,
    Exportmodal
  },
  data () {
    return {
      role: '',
      tout: '',
      drawer: null,
      istableloading: false,
      whtSearch: '',
      totalprice: '0.00',
      subtotalprice: '0.00',
      vatamount: '0.00',
      selected: [],
      items: [],
      headers: [
        // { text: 'No.', value: 'index', sortable: false, align: 'center' },
        { text: 'E-WHT No.', value: 'invoice_no', align: 'left' },
        { text: 'Invoice No.', value: 'invoice_no', align: 'left' },
        { text: 'Pay To', value: 'company_name', align: 'left' },
        { text: 'Payment Date', value: 'createdAt', align: 'center' },
        { text: 'Amount', value: 'amount', align: 'right' },
        { text: 'WHT Rate (%)', value: 'wht_rate', align: 'right' },
        { text: 'WHT', value: 'wht_amount_pay', align: 'right' },
        { text: 'Payment Amount', value: 'pay_amount', align: 'right' },
        { text: 'Status', value: 'wht_status', align: 'center' }
      ],
      bills: [],
      rowperpage: [
        5,
        10,
        25,
        { text: '$vuetify.dataIterator.rowsPerPageAll', value: -1 }
      ]
    }
  },

  methods: {
    opentotalpaymodal (totalpay, price, subtotalprice, vat) {
      if (totalpay.length === 0) {
        alert('Please select an invoice.')
      } else {
        this.totalpricepay = price
        this.totalExcVat = subtotalprice
        this.totalvatamount = vat // vat amount
        this.currenttotalpay = totalpay

        this.$cookies.set('currenttotalpay', JSON.stringify(this.currenttotalpay))
        this.$cookies.set('totalpricepay', this.totalpricepay)
        this.$cookies.set('totalExcVat', this.totalExcVat)
        this.$cookies.set('totalvatamount', this.totalvatamount)
        this.$router.push('/summarybills')
      }
    },
    openinvoicemodal (invoiceno) {
      this.currentinvoiceno = invoiceno
      this.invoicemodal = true
    },
    async getmybill () {
      try {
        this.istableloading = true
        var { data } = await this.axios.get(`${process.env.VUE_APP_APIHOST}/wht_data`, {
          headers: {
            Authorization: this.$cookies.get('token')
          }
        })
        // console.log('wht: ', data)
        this.bills = data
        this.bills = this.bills.filter(bill => bill.company_name == this.selectedcpn)
        this.istableloading = false
      } catch (error) {
        this.istableloading = false
        console.log(error.message)
      }
    },
    sessionTimeout () {
      if (this.isIdle === true) {
        this.$router.push('/')
      }
    },
    addCommas (nStr) {
      nStr += ''
      var x = nStr.split('.')
      var x1 = x[0]
      var x2 = x.length > 1 ? '.' + x[1] : ''
      var rgx = /(\d+)(\d{3})/
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2')
      }
      return x1 + x2
    },
    handleView () {
      this.mobileView = window.innerWidth <= 990
    }
  },
  computed: {
    billsview () {
      return this.bills.map(bill => {
        return {
          ...bill,
          // notiText,
          createdAt:moment(((bill.createdAt).substr(0, 7)).replace(/-/g, "")).format('D MMMM YYYY'),
          vat_amount:
              this.addCommas(bill.vat_amount.toFixed(2)) + ' THB',
          amount:
              this.addCommas(bill.amount.toFixed(2)) + ' THB',
          wht_amount_pay:
              this.addCommas(bill.wht_amount_pay.toFixed(2)) + ' THB',
          pay_amount:
              this.addCommas(bill.pay_amount.toFixed(2)) + ' THB',
        }
      })
    },
    invoicemodal: sync('invoicemodal'),
    currentinvoiceno: sync('currentinvoiceno'),
    tokenHashTaxid: sync('tokenHashTaxid'),
    exportmodal: sync('exportmodal'),
    selectedcpn: sync('selectedcpn')
  },
  watch: {
    selectedcpn(){
      this.getmybill()
    },
    tokenHashTaxid (data) {
      if (data) {
        // console.log('check tokenHashTaxid: ', data);
        this.$cookies.set('token', data)
        this.getmybill()
      }
    }
  },
  created () {
    // this.getmybill()
    this.handleView()
    window.addEventListener('resize', this.handleView)
    // console.log('role: ', this.$cookies.get('role'));
    this.role = this.$cookies.get('role')
    var tokenHashTaxid = this.$cookies.get('tokenHashTaxid')
    if ( (this.role === 'Admin' && tokenHashTaxid) || (this.role === 'User' && this.$cookies.get('token')) ) {
      this.getmybill()
    }
  }
}
</script>

<style>
table.v-table tbody td {
    font-size: 12px !important;
}
.summary{
    font-size: 110%;
}
.item{
    font-size: 140%;
}
.item1{
    font-size: 100%;
}
@media (max-width: 767.98px){
  .action-cell {
    display: inherit;
  }
  .table-headers{
    display: none
  }
  .custom-table-row{
    flex-direction:column;
    min-width:575.98px;
  }
  .mobile-coloumn-name{
    display: inline-block;
    min-width: 100px;
    font-weight:600;
  }
  .summary{
    font-size: 90%;
  }
  .item{
    font-size: 90%;
  }
  .item1{
    font-size: 90%;
}
}
</style>
